<?php
namespace FiloBlu\Storelocator\Model\ResourceModel\Stores;

class Collection extends \Magento\Framework\Model\ResourceModel\Db\Collection\AbstractCollection
{
	/**
	 * @var string
	 * ID for Mass Actions
	 */
	protected $_idFieldName = 'store_id';

	/**
	 * Define resource model
	 *
	 * @return void
	 */
	protected function _construct()
	{
		
		$this->_init('FiloBlu\Storelocator\Model\Stores', 'FiloBlu\Storelocator\Model\ResourceModel\Stores');
	}

	public function addStoreFilter($storeIds = [], $withDefaultStore = true)
	{
		if (!is_array($storeIds)) {
			$storeIds = [$storeIds];
		}
		if ($withDefaultStore && !in_array('0', $storeIds)) {
			array_unshift($storeIds, 0);
		}
		$where = [];
		foreach ($storeIds as $storeId) {
			$where[] = $this->_getConditionSql('store_ids', ['finset' => $storeId]);
		}

		$this->_select->where(implode(' OR ', $where));

		return $this;
	}
	
	public function addFieldToFilter($field, $condition = null)
	{
		if ($field === 'store_ids') {
			$conditionSec = ['finset' => $condition['eq']];
			return parent::addFieldToFilter($field, $conditionSec);
		}
		return parent::addFieldToFilter($field, $condition);
	}
}