<?php

namespace FiloBlu\Storelocator\Model\ResourceModel\Stores\Grid;
use \FiloBlu\Storelocator\Model\ResourceModel\Stores\Collection as StoresCollection;
use \Magento\Framework\Api\Search\SearchResultInterface;

class Collection extends StoresCollection implements SearchResultInterface
{
	public function __construct(

		/**
		 * @param \Magento\Framework\Data\Collection\EntityFactoryInterface $entityFactory
		 * @param \Psr\Log\LoggerInterface $logger
		 * @param \Magento\Framework\Data\Collection\Db\FetchStrategyInterface $fetchStrategy
		 * @param \Magento\Framework\Event\ManagerInterface $eventManager
		 * @param string $mainTable
		 * @param string $eventPrefix
		 * @param string $eventObject
		 * @param string $resourceModel
		 * @param string $model
		 * @param \Magento\Framework\DB\Adapter\AdapterInterface|string|null $connection
		 * @param \Magento\Framework\Model\ResourceModel\Db\AbstractDb $resource
		 *
		 * @SuppressWarnings(PHPMD.ExcessiveParameterList)
		 */
		\Magento\Framework\Data\Collection\EntityFactoryInterface $entityFactory,
		\Psr\Log\LoggerInterface $logger,
		\Magento\Framework\Data\Collection\Db\FetchStrategyInterface $fetchStrategy,
		\Magento\Framework\Event\ManagerInterface $eventManager,
		$mainTable,
		$eventPrefix,
		$eventObject,
		$resourceModel,
		$model = \Magento\Framework\View\Element\UiComponent\DataProvider\Document::class,
		\Magento\Framework\DB\Adapter\AdapterInterface $connection = null,
		\Magento\Framework\Model\ResourceModel\Db\AbstractDb $resource = null
	) {
		
		parent::__construct(
			$entityFactory,
			$logger,
			$fetchStrategy,
			$eventManager,
			$connection,
			$resource
		);
		$this->_eventPrefix = $eventPrefix;
		$this->_eventObject = $eventObject;
		$this->_init($model, $resourceModel);
		$this->setMainTable($mainTable);
	}

	/**
	 * @return AggregationInterface
	 */
	public function getAggregations()
	{
		return $this->aggregations;
	}

	/**
	 * @param AggregationInterface $aggregations
	 * @return $this
	 */
	public function setAggregations($aggregations)
	{
		$this->aggregations = $aggregations;
		return $this;
	}

	/**
	 * Get search criteria.
	 *
	 * @return \Magento\Framework\Api\SearchCriteriaInterface|null
	 */
	public function getSearchCriteria()
	{
		return null;
	}

	/**
	 * Set search criteria.
	 *
	 * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
	 * @return $this
	 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
	 */
	public function setSearchCriteria(\Magento\Framework\Api\SearchCriteriaInterface $searchCriteria = null)
	{
		return $this;
	}

	/**
	 * Get total count.
	 *
	 * @return int
	 */
	public function getTotalCount()
	{
		return $this->getSize();
	}

	/**
	 * Set total count.
	 *
	 * @param int $totalCount
	 * @return $this
	 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
	 */
	public function setTotalCount($totalCount)
	{
		return $this;
	}

	/**
	 * Set items list.
	 *
	 * @param \Magento\Framework\Api\ExtensibleDataInterface[] $items
	 * @return $this
	 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
	 */
	public function setItems(array $items = null)
	{
		return $this;
	}
}